/**
 * File: can-spell.cpp
 * -------------------
 * Provides a test harness for an application that determines
 * whether words can be formed from a collectin of letter cubes.
 */
#include <string>
using namespace std;
#include "console.h"
#include "simpio.h"
#include "vector.h"
#include "stack.h"
#include "strlib.h"
const string kCubesArray[] = {
    "aaeegn", "abbjoo", "achops", "affkps",
    "aoottw", "cimotu", "deilrx", "delvry",
    "distty", "eeghnw", "eeinsu", "ehrtvw",
    "eiosst", "elrtty", "himnqu", "hlnnrz"
};
static void buildCubes(Vector<string>& cubes) {
    for (int i = 0; i < sizeof(kCubesArray)/sizeof(kCubesArray[0]); i++) {
        cubes.add(kCubesArray[i]);
    }
}

static bool canSpellRec(const string& str, Vector<string>& cubes, Stack<string>& selections) {
    // replace the following line with your own implementation
    return false;
}

static bool canSpell(const string& str, const Vector<string>& cubes, Stack<string>& selections) {
    Vector<string> copy = cubes; // make copy. we need something we can modify
    return canSpellRec(str, copy, selections);
}

int main() {
    Vector<string> cubes;
    buildCubes(cubes);
    while (true) {
        string response =
            toLowerCase(getLine("Enter a word you're trying to spell [or hit <enter> to quit]: "));
        if (response.empty()) break;
        Stack<string> selections;
        if (canSpell(response, cubes, selections)) {
            cout << "I can spell that this way: " << endl;
            cout << "  ";
            while (!selections.isEmpty()) {
                cout << " " << selections.pop();
            }
            cout << endl;
        } else {
            cout << "No, I can't spell that.  Sorry." << endl;
        }
    }
    
    return 0;
}
